diff --git pdns-4.0.7/pdns/mastercommunicator.cc pdns-4.0.7-invalidrecords/pdns/mastercommunicator.cc
index 5bd8336..c90a872 100644
--- pdns-4.0.7/pdns/mastercommunicator.cc
+++ pdns-4.0.7-invalidrecords/pdns/mastercommunicator.cc
@@ -54,6 +54,7 @@ void CommunicatorClass::queueNotifyDomain(const DNSName &domain, UeberBackend *B
     while(B->get(rr))
       nsset.insert(rr.content);
 
+    try {
     for(set<string>::const_iterator j=nsset.begin();j!=nsset.end();++j) {
       vector<string> nsips=fns.lookup(DNSName(*j), B);
       if(nsips.empty())
@@ -68,7 +69,17 @@ void CommunicatorClass::queueNotifyDomain(const DNSName &domain, UeberBackend *B
               ips.insert(caIp.toStringWithPort());
           }
         }
+      }
+    }
+    catch (PDNSException &ae) {
+      L << Logger::Error << "Error looking up name servers for " << domain << ", cannot notify: " << ae.reason << endl;
+      return;
     }
+    catch (std::exception &e) {
+      L << Logger::Error << "Error looking up name servers for " << domain << ", cannot notify: " << e.what() << endl;
+      return;
+    }
+
 
     for(set<string>::const_iterator j=ips.begin();j!=ips.end();++j) {
       L<<Logger::Warning<<"Queued notification of domain '"<<domain<<"' to "<<*j<<endl;
